function classAdd(domNode, className){
    if (domNode == undefined || domNode.className == undefined)
        return;

    if (className instanceof Array){
        for(var i = 0; i < className.length; i++)
            classAdd(domNode, className[i]);
        return;
    }   

    if (classHas(domNode, className))
        return;

    var classes = domNode.className.split(' ');
    classes.push(className);
    domNode.className = classes.join(' ').trim();
}

function classRemove(domNode, className){
    if (domNode == undefined || domNode.className == undefined)
        return;

    if (!classHas(domNode, className))
        return;
    var classes = domNode.className.split(' ');
    var classesSet = [];
    for (var i = 0; i < classes.length; i++){
        if (classes[i] == className)
            continue;
        classesSet.push(classes[i]);
    }
    domNode.className = classesSet.join(' ');
}

function classHas(domNode, className){
    if (domNode == undefined || domNode.className == undefined)
        return false;
    
    return ~domNode.className.split(' ').indexOf(className);
}

function getValueKey(value, obj) {
    for (var k in obj)
        if (obj[k] == value)
            return k;

    return undefined;
}

function getKeyCount(obj) {
    var count = 0;
    for (var key in obj) count++;
    return count;
}

function getFirstKey(obj) {
    var first_key = undefined;
    for (var key in obj) {
        first_key = key;
        break;
    }
    return first_key;
}

function getLastKey(obj) {
    var last_key = undefined;
    for (var key in obj) {
        last_key = key;
    }
    return last_key;
}

function getNextKey(prev_key, obj, repeat) {
    var return_key = undefined;
    if (getKeyCount(obj) == 0) return return_key;
    var last_key = getLastKey(obj);
    if (repeat && last_key == prev_key) return getFirstKey(obj);
    var prev_key_obj = -1;
    for (var key in obj) {
        if (prev_key_obj == prev_key) {
            return_key = key;
            break;
        }
        prev_key_obj = key;
    }
    return return_key;
}

function getPrevKey(next_key, obj, repeat) {
    var return_key = undefined;
    if (getKeyCount(obj) == 0) return return_key;
    var first_key = getFirstKey(obj);
    if (repeat && first_key == next_key) return getLastKey(obj);
    var prev_key_obj = -1;
    for (var key in obj) {
        if (key == next_key && prev_key_obj != -1) {
            return_key = prev_key_obj;
            break;
        }
        prev_key_obj = key;
    }
    return return_key;
}

function removeValue(value, obj) {
    var key = getValueKey(value, obj);
    if (key == undefined)
        return false;

    delete obj[key];
    return true;
}

String.prototype.trim = function trim(text) {
    return this.replace(/^\s*/, '').replace(/\s*$/, '');
}

function moveToTop() {
    $('body').animate({scrollTop: 0}, 200);
}